// Bambino
// TAB FILE > mind47.ino

//     MIND - getMind(), saveMind(),
//            initialiseEEPROM(), initBehaviour8(), initialiseEEPROMbehaviours1to7()  
//===========================================================
//NEW
//getMind() offset constants replaced by actual values - clearer to read
//deleted initEEPROM_GWU(), entries put in initBehaviour8()
//== Mind ==================================================
/*
varsCons47.h
//addresses within a behaviour slot, base is BehaviourEEbase
const byte Es31f_walking    =31;
const byte Es30rollC        =30;   // adjust servos
const byte Es29paceC        =29;   // adjust servos
const byte Es28rollby       =28;   // adjust servos
const byte Es27paceby       =27;   // adjust servos
const byte Es26rollmin      =26;   // adjust servos
const byte Es25rollmax      =25;   // adjust servos
const byte Es24pacemin      =24;   // adjust servos
const byte Es23pacemax      =23;   // adjust servos
const byte Es22rgroup       =22;   // 'b#'
const byte Es21rname        =21;   // 'b#'   
const byte Es20autoAct      =20;   // 'ba'
const byte Es19SonarAwareAt =19;   // 'bus'
const byte Es18SonarTooNear =18;   // 'bus'
const byte Es17f_cm         =17;   // 'bc0',bc1'
const byte Es16rollspeedmax =16;
const byte Es15pacespeedmax =15;
const byte Es14rollspeed    =14;
const byte Es13pacespeed    =13;
const byte Es12senseG       =12;
const byte Es11senseW       =11;
const byte Es10senseU       =10;
//                           0 is default behaviour marker ' ','@'
*/
//-----------------------------------------------------------     
void getMind()           //"b"<behaviour>
{
  f_walking    =EEPROM.read(BehaviourEbase +31);
  rollC        =EEPROM.read(BehaviourEbase +30);    // initialise rollC from EEPROM, stand upright value
  paceC        =EEPROM.read(BehaviourEbase +29);    // initialise paceC from EEPROM, feet together value
  rollby       =EEPROM.read(BehaviourEbase +28);    // set to EEPROM value
  paceby       =EEPROM.read(BehaviourEbase +27);    // set to EEPROM value
  turnby       =paceby;
  //23-26 never altered
  rgroup       =EEPROM.read(BehaviourEbase +22);
  rname        =EEPROM.read(BehaviourEbase +21);
  autoAct      =EEPROM.read(BehaviourEbase +20);
  SonarAwareAt =EEPROM.read(BehaviourEbase +19);
  SonarTooNear =EEPROM.read(BehaviourEbase +18);
  f_cm         =EEPROM.read(BehaviourEbase +17);
  rollspeedmax =EEPROM.read(BehaviourEbase +16);
  pacespeedmax =EEPROM.read(BehaviourEbase +15);
  rollspeed    =EEPROM.read(BehaviourEbase +14);
  pacespeed    =EEPROM.read(BehaviourEbase +13);
  f_bG         =EEPROM.read(BehaviourEbase +12);
  f_bW         =EEPROM.read(BehaviourEbase +11);
  f_bU         =EEPROM.read(BehaviourEbase +10);      
  //0 '@' indicates current behaviour, otherwise '.' 
}
//-----------------------------------------------------------     
void saveMind()         //"bs"<behaviour>
{ // slotbase so current BehaviourEEbase is not changed
  EEPROM.write(slotbase +31, f_walking);
  EEPROM.write(slotbase +30, rollC);
  EEPROM.write(slotbase +29, paceC);
  EEPROM.write(slotbase +28, rollby);
  EEPROM.write(slotbase +27, paceby);
  //23-26 never altered
  EEPROM.write(slotbase +22, rgroup);
  EEPROM.write(slotbase +21, rname);
  EEPROM.write(slotbase +20, autoAct);
  EEPROM.write(slotbase +19, SonarAwareAt);
  EEPROM.write(slotbase +18, SonarTooNear);
  EEPROM.write(slotbase +17, f_cm);
  EEPROM.write(slotbase +16, rollspeedmax);
  EEPROM.write(slotbase +15, pacespeedmax);
  EEPROM.write(slotbase +14, rollspeed);
  EEPROM.write(slotbase +13, pacespeed);
  EEPROM.write(slotbase +12, f_bG);
  EEPROM.write(slotbase +11, f_bW);
  EEPROM.write(slotbase +10, f_bU);
  //0 '@' indicates current behaviour, otherwise '.' 
}
//-----------------------------------------------------------     
void initialiseEEPROM()     //Behaviour slot 8
{
  initBehaviour8();                   //init EEPROM behaviour8
  initialiseEEPROMbehaviours1to7();   //copy behaviour8 to other behaviours
}
//-----------------------------------------------------------     

void initBehaviour8()             //init EEPROM behaviour8
{
  EEPROM.write(E8f_walking,0);    // 31 - 0 =>stopped, 1 =>walking
  EEPROM.write(E8rollC,90);       // 30 - nominal roll centre = 90 degrees (ie 1500us) => upright
  EEPROM.write(E8paceC,90);       // 29 - nominal pace centre = 90 degrees (ie 1500us) => feet together
  //rollbymax absolute max is 90+-20, above that the tilt rods hit the body
  EEPROM.write(E8rollby,15);      // 28 - nominal Roll for walking
  //pacebymax absolute max is 90+-20, above that the tilt rods hit the rear femur 
  //and the horn screws hit the leg body
  EEPROM.write(E8paceby,15);      // 27 - nominal Pace for walking
  //EEPROM.write(E8rollmin,70);     // 26 - nominal minimum roll value, not used at present     
  //EEPROM.write(E8rollmax,110);    // 25 - nominal maximum roll value, not used at present
  //EEPROM.write(E8pacemin,75);     // 24 - nominal minimum pace value, not used at present 
  //EEPROM.write(E8pacemax,105);    // 23 - nominal maximum pace value, not used at present
  //core parameters of Slot8 now initialised   
  EEPROM.write(E8rgroup,      '0'); //22 - '0-9',
  EEPROM.write(E8rname,       'a'); //21 - 'A-z'
  EEPROM.write(E8autoAct,     '0'); //20 - '0-8'
  EEPROM.write(E8SonarAwareAt,5  ); //19 - 1-9  init(5) -> SonarAwareAt
  EEPROM.write(E8SonarTooNear,2  ); //18 - 1-9  init(2) -> SonarTooNear
  EEPROM.write(E8f_cm,       true); //17 - true,false       
  EEPROM.write(E8rollspeedmax,4  ); //16 - 1-9
  EEPROM.write(E8pacespeedmax,6  ); //15 - 1-9
  EEPROM.write(E8rollspeed,   1  ); //14 - 1-9
  EEPROM.write(E8pacespeed,   1  ); //13 - 1-9
  EEPROM.write(E8Greact,      0  ); //12 - 0,1  Ground     react
  EEPROM.write(E8Wreact,      0  ); //11 - 0,1  Whiskers   react
  EEPROM.write(E8Ureact,      0  ); //10 - 0,1  Ultrasonic react
  EEPROM.write(E8AutoSense,   0  ); // 9 - 0,1   
  EEPROM.write(224,           '@'); //0  - ' ','@'
}
//-----------------------------------------------------------     
void initialiseEEPROMbehaviours1to7()
//in earlier programs to 45 slot8 was the only behaviour
{ for (BehaviourEbase =0; BehaviourEbase<224; BehaviourEbase +=32 )          //7 slots 
  { for (byte i =1; i<32; i++)
      { EEPROM.write(BehaviourEbase +i, EEPROM.read(224 +i) );               //copy from slot 8
        EEPROM.write(BehaviourEbase,'.');                                    //not default behaviour
      }
   }
}   
//-----------------------------------------------------------
